diff -pruN 2.3.1-1/debian/changelog 2.3.1-2/debian/changelog
--- 2.3.1-1/debian/changelog	2024-05-06 21:19:50.000000000 +0000
+++ 2.3.1-2/debian/changelog	2024-07-05 17:59:13.000000000 +0000
@@ -1,3 +1,9 @@
+kernelshark (2.3.1-2) unstable; urgency=medium
+
+  * Add upstream patch to fix FTBFS with gcc-14. (Closes: #1075112)
+
+ -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 05 Jul 2024 18:59:13 +0100
+
 kernelshark (2.3.1-1) unstable; urgency=medium
 
   * New upstream version 2.3.1
diff -pruN 2.3.1-1/debian/patches/0001-kernelshark-fix-compiling-error-in-LatencyPlot.cpp.patch 2.3.1-2/debian/patches/0001-kernelshark-fix-compiling-error-in-LatencyPlot.cpp.patch
--- 2.3.1-1/debian/patches/0001-kernelshark-fix-compiling-error-in-LatencyPlot.cpp.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.3.1-2/debian/patches/0001-kernelshark-fix-compiling-error-in-LatencyPlot.cpp.patch	2024-07-05 17:58:19.000000000 +0000
@@ -0,0 +1,35 @@
+From 9e33324644fff49b7aa15d34f836e72af8b32c78 Mon Sep 17 00:00:00 2001
+From: Jerome Marchand <jmarchan@redhat.com>
+Date: Tue, 11 Jun 2024 17:33:34 +0200
+Subject: [PATCH] kernelshark: fix compiling error in LatencyPlot.cpp
+
+Include the <algorithm> header to use std::for_each.
+
+Fixes the following compilation error:
+kernel-shark/src/plugins/LatencyPlot.cpp: In function void draw_latency(kshark_cpp_argv*, int, int, int):
+kernel-shark/src/plugins/LatencyPlot.cpp:306:14: error: for_each is not a member of std
+  306 |         std::for_each(range.first, range.second, lamPlotLat);
+      |              ^~~~~~~~
+
+Signed-off-by: Jerome Marchand <jmarchan@redhat.com>
+
+Origin: upstream, https://git.kernel.org/pub/scm/utils/trace-cmd/kernel-shark.git/commit/?id=9e33324644fff49b7aa15d34f836e72af8b32c78
+Bug-Debian: https://bugs.debian.org/1075112
+Last-Update: 2024-07-05
+---
+ src/plugins/LatencyPlot.cpp | 1 +
+ 1 file changed, 1 insertion(+)
+
+--- a/src/plugins/LatencyPlot.cpp
++++ b/src/plugins/LatencyPlot.cpp
+@@ -15,6 +15,7 @@
+ // C++
+ #include <unordered_map>
+ #include <iostream>
++#include <algorithm>
+ 
+ // KernelShark
+ #include "plugins/latency_plot.h"
+-- 
+2.39.2
+
diff -pruN 2.3.1-1/debian/patches/series 2.3.1-2/debian/patches/series
--- 2.3.1-1/debian/patches/series	2024-05-06 21:19:50.000000000 +0000
+++ 2.3.1-2/debian/patches/series	2024-07-05 17:54:25.000000000 +0000
@@ -1 +1,2 @@
 remove_rpath.patch
+0001-kernelshark-fix-compiling-error-in-LatencyPlot.cpp.patch
